diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index 1b95542cc..fdd9b2918 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -3,9 +3,10 @@ package net.minecraft.client.render;
 import java.util.HashMap;
 import java.util.Map;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.entity.*;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.model.*;
+import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.EntityPainting;
@@ -22,6 +23,9 @@ import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
@@ -38,173 +42,158 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
-import net.minecraft.core.world.World;
 
-public class EntityRenderDispatcher
+public final class EntityRenderDispatcher
 {
-    private EntityRenderDispatcher()
-    {
-        renderers = new HashMap<>();
-        renderers.put(MobSpider.class, new MobRendererSpider());
-        renderers.put(MobScorpion.class, new MobRendererScorpion());
-        renderers.put(MobPig.class, new MobRendererPig(new ModelPig(), new ModelPig(0.5F), 0.7F));
-        renderers.put(MobSheep.class, new MobRendererSheep(new ModelSheep(), new ModelSheepWool(), new ModelSheepOverlay(), 0.7F));
-        renderers.put(MobCow.class, new MobRendererCow(new ModelCow(), 0.7F));
-        renderers.put(MobWolf.class, new MobRendererWolf(new ModelWolf(0.0f), 0.5F));
-        renderers.put(MobChicken.class, new MobRendererChicken(new ModelChicken(), 0.3F));
-        renderers.put(MobCreeper.class, new MobRendererCreeper());
-        renderers.put(MobSkeleton.class, new MobRendererBipedArmored<>(new ModelSkeleton(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
-        renderers.put(MobZombie.class, new MobRendererBipedArmored<>(new ModelZombie(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
-        renderers.put(MobZombiePig.class, new MobRendererBipedArmored<>(new ModelZombiePigman(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
-        renderers.put(MobSnowman.class, new MobRendererBiped<>(new ModelZombie(), 0.5F));
-        renderers.put(MobZombieArmored.class, new MobRendererZombieArmored(new ModelZombie(), 0.5F));
-        renderers.put(MobSlime.class, new MobRendererSlime(new ModelSlime(16), new ModelSlime(0), 0.25F));
-        renderers.put(Player.class, new MobRendererPlayer());
-        renderers.put(MobHuman.class, new MobRendererHuman());
-        renderers.put(MobGiant.class, new MobRendererGiant(new ModelZombie(), 0.5F, 6F));
-        renderers.put(MobGhast.class, new MobRendererGhast());
-        renderers.put(MobSquid.class, new MobRendererSquid(new ModelSquid(), 0.7F));
-        renderers.put(Mob.class, new MobRenderer<>(new ModelBiped(), 0.5F));
-        renderers.put(Entity.class, new EntityRendererDefault());
-        renderers.put(EntityPainting.class, new EntityRendererPainting());
-        renderers.put(ProjectileArrow.class, new EntityRendererArrow());
-        renderers.put(ProjectileSnowball.class, new EntityRendererSprite<ProjectileSnowball>(Items.AMMO_SNOWBALL));
-        renderers.put(ProjectileEgg.class, new EntityRendererSprite<ProjectileEgg>(Items.EGG_CHICKEN));
-        renderers.put(ProjectileFireball.class, new EntityRendererSprite<ProjectileFireball>(Items.AMMO_FIREBALL).setScale(4).setFullBright());
-        renderers.put(EntityItem.class, new EntityRendererItem());
-        renderers.put(EntityPrimedTNT.class, new EntityRendererTNT());
-        renderers.put(EntityFallingBlock.class, new EntityRendererFallingBlock());
-        renderers.put(EntityMinecart.class, new EntityRendererMinecart());
-        renderers.put(EntityBoat.class, new EntityRendererBoat());
-        renderers.put(EntityFishingBobber.class, new EntityRendererFishingBobber());
-        renderers.put(MobFireflyCluster.class, new MobRendererFireflyCluster());
-        renderers.put(EntityLightning.class, new EntityRendererLightningBolt());
-        renderers.put(ProjectileCannonball.class, new EntityRendererCannonball());
-        renderers.put(ProjectilePebble.class, new EntityRendererSprite<ProjectilePebble>(Items.AMMO_PEBBLE));
-        renderers.put(MobButterfly.class, new MobRendererButterfly());
-
-        for (EntityRenderer<?> renderer : renderers.values())
-        {
-            renderer.init(this);
-        }
+    public static final @NotNull EntityRenderDispatcher instance = new EntityRenderDispatcher();
+    public static double renderPosX = 0;
+    public static double renderPosY = 0;
+    public static double renderPosZ = 0;
+
+    private final @NotNull Map<@NotNull Class<? extends Entity>, @Nullable EntityRenderer<? extends Entity>> renderers;
+    public final @NotNull TextureManager textureManager;
+    public final @NotNull TexturePackList packList;
+    public final @NotNull FontRenderer font;
+    public final @NotNull GameSettings settings;
+    public @Nullable World world;
+    public @Nullable ICamera camera;
+    public float viewLerpYaw = 0;
+    public float viewLerpPitch = 0;
+    public double viewLerpPosX = 0;
+    public double viewLerpPosY = 0;
+    public double viewLerpPosZ = 0;
+
+    private EntityRenderDispatcher() {
+        final Minecraft mc = Minecraft.getMinecraft();
+        this.textureManager = mc.textureManager;
+        this.packList = mc.texturePackList;
+        this.font = mc.font;
+        this.settings = mc.gameSettings;
+
+        this.renderers = new HashMap<>();
+        reload();
+    }
+
+    public void reload() {
+        this.renderers.clear();
+        assignRenderer(MobSpider.class, new MobRendererSpider(1));
+        assignRenderer(MobScorpion.class, new MobRendererScorpion(0.5f));
+        assignRenderer(MobPig.class, new MobRendererPig(0.7F));
+        assignRenderer(MobSheep.class, new MobRendererSheep(0.7F));
+        assignRenderer(MobCow.class, new MobRendererQuadruped<>(0.7F));
+        assignRenderer(MobWolf.class, new MobRendererWolf(0.5F));
+        assignRenderer(MobChicken.class, new MobRendererChicken(0.3F));
+        assignRenderer(MobCreeper.class, new MobRendererCreeper(0.5f));
+        assignRenderer(MobSkeleton.class, new MobRendererSkeleton(0.5F));
+        assignRenderer(MobZombie.class, new MobRendererZombie(0.5F));
+        assignRenderer(MobZombiePig.class, new MobRendererZombie(0.5F));
+        assignRenderer(MobSnowman.class, new MobRendererSnowman(0.5F));
+        assignRenderer(MobZombieArmored.class, new MobRendererZombieArmored(0.5F));
+        assignRenderer(MobSlime.class, new MobRendererSlime(0.25F));
+        assignRenderer(Player.class, new MobRendererPlayer());
+        assignRenderer(MobHuman.class, new MobRendererHuman());
+        assignRenderer(MobGiant.class, new MobRendererGiant(0.5F, MobGiant.GIANT_SCALE));
+        assignRenderer(MobGhast.class, new MobRendererGhast(0.5f));
+        assignRenderer(MobSquid.class, new MobRendererSquid(0.7F));
+        assignRenderer(Entity.class, new EntityRendererDefault());
+        assignRenderer(Mob.class, new EntityRendererDefault());
+        assignRenderer(EntityPainting.class, new EntityRendererPainting());
+        assignRenderer(ProjectileArrow.class, new EntityRendererArrow());
+        assignRenderer(ProjectileSnowball.class, new EntityRendererSprite<>(Items.AMMO_SNOWBALL));
+        assignRenderer(ProjectileEgg.class, new EntityRendererSprite<>(Items.EGG_CHICKEN));
+        assignRenderer(ProjectileFireball.class, new EntityRendererSprite<ProjectileFireball>(Items.AMMO_FIREBALL).setScale(4).setFullBright());
+        assignRenderer(EntityItem.class, new EntityRendererItem());
+        assignRenderer(EntityPrimedTNT.class, new EntityRendererTNT());
+        assignRenderer(EntityFallingBlock.class, new EntityRendererFallingBlock());
+        assignRenderer(EntityMinecart.class, new EntityRendererMinecart());
+        assignRenderer(EntityBoat.class, new EntityRendererBoat());
+        assignRenderer(EntityFishingBobber.class, new EntityRendererFishingBobber());
+        assignRenderer(MobFireflyCluster.class, new MobRendererFireflyCluster());
+        assignRenderer(EntityLightning.class, new EntityRendererLightningBolt());
+        assignRenderer(ProjectileCannonball.class, new EntityRendererCannonball());
+        assignRenderer(ProjectilePebble.class, new EntityRendererSprite<>(Items.AMMO_PEBBLE));
+        assignRenderer(MobButterfly.class, new MobRendererButterfly());
+    }
+
+    private <T extends Entity> void assignRenderer(final @NotNull Class<? extends T> clazz, final @NotNull EntityRenderer<T> renderer) {
+        this.renderers.put(clazz, renderer);
+        renderer.init(clazz, this);
     }
 
     @SuppressWarnings("unchecked") // trust me this is safe, Notch did it first
-    public <T extends Entity> EntityRenderer<T> getRenderer(Class<? extends Entity> e)
-    {
-        EntityRenderer<? extends Entity> r = renderers.get(e);
-        if(r == null && e != Entity.class)
-        {
+    public <T extends Entity> EntityRenderer<T> getRenderer(final @NotNull Class<T> e) {
+        EntityRenderer<? extends Entity> r = this.renderers.get(e);
+        if(r == null && e != Entity.class) {
             r = getRenderer((Class<? extends Entity>) e.getSuperclass());
-            renderers.put(e, r);
+            this.renderers.put(e, r);
         }
         return (EntityRenderer<T>) r;
     }
 
-    public <T extends Entity> EntityRenderer<T> getRenderer(Entity entity)
-    {
-        return getRenderer(entity.getClass());
+    @SuppressWarnings("unchecked")
+    public <T extends Entity> EntityRenderer<T> getRenderer(final @NotNull T entity) {
+        return (EntityRenderer<T>) getRenderer(entity.getClass());
     }
 
-    public void cacheActiveRenderInfo(World world, TextureManager textureManager, FontRenderer fontRenderer, ICamera camera, GameSettings gameSettings, float partialTick)
+    public void cacheActiveRenderInfo(final @NotNull World world, final @NotNull ICamera camera, final float partialTick)
     {
+        if(this.world != world) {
+            for (final @Nullable EntityRenderer<?> renderer : this.renderers.values()) {
+                if (renderer == null) continue;
+                renderer.onWorldChanged(world);
+            }
+        }
         this.world = world;
-        this.textureManager = textureManager;
-        this.gameSettings = gameSettings;
-        this.fontRenderer = fontRenderer;
         this.camera = camera;
-        viewLerpYaw = (float) camera.getYRot(partialTick);
-        viewLerpPitch = (float) camera.getXRot(partialTick);
-        viewLerpPosX = (float) camera.getX(partialTick);
-        viewLerpPosY = (float) camera.getY(partialTick);
-        viewLerpPosZ = (float) camera.getZ(partialTick);
+        this.viewLerpYaw = (float) camera.getYRot(partialTick);
+        this.viewLerpPitch = (float) camera.getXRot(partialTick);
+        this.viewLerpPosX = camera.getX(partialTick);
+        this.viewLerpPosY = camera.getY(partialTick);
+        this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends Entity> void renderEntity(Tessellator tessellator, T entity, float partialTick)
-    {
-        double lerpPosX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
-        double lerpPosY = entity.yo + (entity.y - entity.yo) * (double)partialTick;
-        double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
-        float lerpYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
+    public <T extends Entity> void renderEntity(final Tessellator tessellator, final T entity, final float partialTick) {
+        final double lerpPosX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
+        final double lerpPosY = entity.yo + (entity.y - entity.yo) * (double)partialTick;
+        final double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
+        final float lerpYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
         float brightness;
-        
+
         if(LightmapHelper.isLightmapEnabled()) {
         	brightness = 1.0f;
-        	
+
         	LightmapHelper.setLightmapCoord(entity.getLightmapCoord(partialTick));
-        }else if(Global.accessor.isFullbrightEnabled()) {
+        } else if(Global.accessor.isFullbrightEnabled()) {
         	brightness = 1.0f;
-        }else {
+        } else {
         	brightness = entity.getBrightness(partialTick);
         }
-        
+
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         GL11.glColor3f(brightness, brightness, brightness);
-        
+
         renderEntityWithPosYaw(tessellator, entity, lerpPosX - renderPosX, lerpPosY - renderPosY, lerpPosZ - renderPosZ, lerpYaw, partialTick);
     }
 
-    public <T extends Entity> void renderEntityWithPosYaw(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick)
-    {
-        EntityRenderer<T> renderer = getRenderer(entity);
-        if(renderer != null)
-        {
+    public <T extends Entity> void renderEntityWithPosYaw(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        final EntityRenderer<T> renderer = getRenderer(entity);
+        if(renderer != null) {
             renderer.render(tessellator, entity, x, y, z, yaw, partialTick);
             renderer.postRender(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
 
-    public <T extends Entity> void renderEntityPreviewWithPosYaw(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick)
-    {
-        EntityRenderer<T> renderer = getRenderer(entity);
-        if(renderer != null)
-        {
+    public <T extends Entity> void renderEntityPreviewWithPosYaw(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        final EntityRenderer<T> renderer = getRenderer(entity);
+        if(renderer != null) {
             renderer.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
 
-    public void unloadEntityRenderers(){
-        // Needs to be run to clear any instances of entity inside the model classes.
-        // Not running can cause a temporary gc deadlock where old world objects are not cleared as the entity renderer is retained by the dispatcher.
-        for (EntityRenderer<?> renderer : renderers.values())
-        {
-            renderer.onUnload();
-        }
-    }
-
-    public void setWorld(World world)
-    {
-        this.world = world;
-    }
-
-    public double distanceToLerpSquared(double x, double y, double z)
-    {
-        double dx = x - viewLerpPosX;
-        double dy = y - viewLerpPosY;
-        double dz = z - viewLerpPosZ;
+    public double distanceToLerpSquared(final double x, final double y, final double z) {
+        final double dx = x - this.viewLerpPosX;
+        final double dy = y - this.viewLerpPosY;
+        final double dz = z - this.viewLerpPosZ;
         return dx * dx + dy * dy + dz * dz;
     }
-
-    public FontRenderer getFont()
-    {
-        return this.fontRenderer;
-    }
-
-    private final Map<Class<?>, EntityRenderer<?>> renderers;
-    public static EntityRenderDispatcher instance = new EntityRenderDispatcher();
-    private FontRenderer fontRenderer;
-    public static double renderPosX;
-    public static double renderPosY;
-    public static double renderPosZ;
-    public TextureManager textureManager;
-    public ItemRenderer itemRenderer;
-    public World world;
-    public ICamera camera;
-    public float viewLerpYaw;
-    public float viewLerpPitch;
-    public GameSettings gameSettings;
-    public double viewLerpPosX;
-    public double viewLerpPosY;
-    public double viewLerpPosZ;
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 3c9e7d855..3900439c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.render.entity.MobRendererPlayer;
 import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
@@ -8,7 +9,6 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.client.render.entity.MobRendererPlayer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -19,10 +19,10 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL12;
-import org.useless.dragonfly.DisplayPos;
 
 import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
 import static org.lwjgl.opengl.GL11.GL_BLEND;
+import static org.lwjgl.opengl.GL11.GL_CCW;
 import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
 import static org.lwjgl.opengl.GL11.glColor4f;
 import static org.lwjgl.opengl.GL11.glDisable;
@@ -106,7 +106,14 @@ public class ItemRenderer
 
                     GL11.glPushMatrix();
                     GL11.glScalef(-1, 1, 1);
-                    playerRenderer.drawFirstPersonHand(mc.thePlayer, true);
+                    GL11.glPushMatrix();
+                    GL11.glScalef(1/16f, 1/16f, -1/16f);
+                    GL11.glTranslatef(0, 16, 0);
+                    GL11.glRotatef(180, 1, 0, 0);
+                    GL11.glTranslatef(0, -16, 0);
+                    GL11.glTranslatef(0, 8, 0);
+                    playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, true);
+                    GL11.glPopMatrix();
                     GL11.glPopMatrix();
                 } else {
                     float f6 = 0.8F;
@@ -126,7 +133,14 @@ public class ItemRenderer
                     GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
                     GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
                     GL11.glTranslatef(5.6F, 0.0F, 0.0F);
-                    playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+                    GL11.glPushMatrix();
+                    GL11.glScalef(1/16f, 1/16f, -1/16f);
+                    GL11.glTranslatef(0, 16, 0);
+                    GL11.glRotatef(180, 1, 0, 0);
+                    GL11.glTranslatef(0, -16, 0);
+                    GL11.glTranslatef(0, 8, 0);
+                    playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, false);
+                    GL11.glPopMatrix();
                 }
             } else {
                 GL11.glPushMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 82b871a68..fdd0e2818 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -98,7 +98,6 @@ public class RenderGlobal
     private int countEntitiesTotal;
     private int countEntitiesRendered;
     private int countEntitiesHidden;
-    int[] dummyBuf50k;
     IntBuffer occlusionResult;
     private int renderersLoaded;
     private int renderersBeingClipped;
@@ -110,8 +109,6 @@ public class RenderGlobal
     private final DisplayList[] allDisplayLists = {
         new DisplayList(), new DisplayList(), new DisplayList(), new DisplayList()
     };
-    int dummyInt0;
-    int glDummyList;
     double prevSortX;
     double prevSortY;
     double prevSortZ;
@@ -133,11 +130,8 @@ public class RenderGlobal
         occlusionEnabled = false;
         cloudOffsetX = 0;
         renderEntitiesStartupCounter = 2;
-        dummyBuf50k = new int[50000];
         occlusionResult = GLAllocation.createDirectIntBuffer(64);
         glRenderLists = new ArrayList<>();
-        dummyInt0 = 0;
-        glDummyList = GLAllocation.generateDisplayLists(1);
         prevSortX = -9999D;
         prevSortY = -9999D;
         prevSortZ = -9999D;
@@ -245,20 +239,18 @@ public class RenderGlobal
         tessellator.draw();
     }
 
-    public void changeWorld(WorldClient world)
+    public void changeWorld(final WorldClient world)
     {
-        if(worldObj != null)
+        if(this.worldObj != null)
         {
-            worldObj.removeListener(this);
+            this.worldObj.removeListener(this);
         }
-        prevSortX = -9999D;
-        prevSortY = -9999D;
-        prevSortZ = -9999D;
-        EntityRenderDispatcher.instance.unloadEntityRenderers();
-        EntityRenderDispatcher.instance.setWorld(world);
-        worldObj = world;
-        auroraBrightness = 0.0f;
-        targetAuroraBrightness = Float.NaN;
+        this.prevSortX = -9999D;
+        this.prevSortY = -9999D;
+        this.prevSortZ = -9999D;
+        this.worldObj = world;
+        this.auroraBrightness = 0.0f;
+        this.targetAuroraBrightness = Float.NaN;
         if(world != null)
         {
             world.addListener(this);
@@ -464,8 +456,8 @@ public class RenderGlobal
             renderEntitiesStartupCounter--;
             return;
         }
-        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, partialTick);
-        EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, mc.gameSettings, partialTick);
+        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, camera, partialTick);
+        EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, camera, partialTick);
         countEntitiesTotal = 0;
         countEntitiesRendered = 0;
         countEntitiesHidden = 0;
@@ -483,7 +475,7 @@ public class RenderGlobal
         {
             Entity entity = worldObj.weatherEffects.get(i);
             countEntitiesRendered++;
-            if(entity.shouldRender(camera.getPosition(partialTick)) || mc.thePlayer.vehicle == entity)
+            if(entity.shouldRender(camera.getPosition(partialTick), 1) || mc.thePlayer.vehicle == entity)
             {
                 EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
@@ -500,7 +492,7 @@ public class RenderGlobal
                     continue;
                 }
             }
-            if (mc.thePlayer.vehicle != entity && (!entity.shouldRender(camera.getPosition(partialTick)) || !entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(entity.bb, partialTick)))
+            if (mc.thePlayer.vehicle != entity && (!entity.shouldRender(camera.getPosition(partialTick), 1) || !entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(EntityRenderDispatcher.instance.getRenderer(entity).entityViewBox(entity), partialTick)))
             {
                 continue;
             }
@@ -1457,7 +1449,6 @@ public class RenderGlobal
 			drawOutlinedBoundingBox(aabb.cloneMove(-offsetX, -offsetY, -offsetZ).grow(expand, expand, expand));
 		}
 
-		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
 		float entityRadius = 10.0f;
 		if(mc.thePlayer.getGamemode() == Gamemode.creative) {
 			entityRadius = 100.0f;
@@ -1483,6 +1474,15 @@ public class RenderGlobal
         boundingBox = boundingBox.cloneMove(-entity.x, -entity.y, -entity.z);
         boundingBox = boundingBox.cloneMove(-cameraX, -cameraY, -cameraZ);
         boundingBox = boundingBox.cloneMove(lerpOffsetX, lerpOffsetY, lerpOffsetZ);
+
+        glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        drawOutlinedBoundingBox(boundingBox);
+
+        glColor4f(1.0f, 0f, 0f, 1.0f);
+        boundingBox = EntityRenderDispatcher.instance.getRenderer(entity).entityViewBox(entity);
+        boundingBox = boundingBox.cloneMove(-entity.x, -entity.y, -entity.z);
+        boundingBox = boundingBox.cloneMove(-cameraX, -cameraY, -cameraZ);
+        boundingBox = boundingBox.cloneMove(lerpOffsetX, lerpOffsetY, lerpOffsetZ);
         drawOutlinedBoundingBox(boundingBox);
     }
 
